Loading...
Searching...
No Matches
Ogre::HardwareVertexBuffer Class Referencefinal
Core » RenderSystem

Specialisation of HardwareBuffer for a vertex buffer. More...

`#include <OgreHardwareVertexBuffer.h>`

Inheritance diagram for Ogre::HardwareVertexBuffer:
[legend]

## Public Member Functions

| HardwareVertexBuffer (HardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, HardwareBuffer *delegate)
| HardwareVertexBuffer (HardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, Usage usage, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareVertexBuffer ()
uint32 | getInstanceDataStepRate () const
| Get the number of instances to draw using the same per-instance data before advancing in the buffer by one element.
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
uint32 | getNumVertices (void) const
| Get the number of vertices in this buffer.
uint32 | getVertexSize (void) const
| Gets the size in bytes of a single vertex in this buffer.
bool | isInstanceData () const
| Get if this vertex buffer is an "instance data" buffer (per instance).
void | setInstanceDataStepRate (const size_t val)
| Set the number of instances to draw using the same per-instance data before advancing in the buffer by one element.
void | setIsInstanceData (const bool val)
| Set if this vertex buffer is an "instance data" buffer (per instance).
Public Member Functions inherited from Ogre::HardwareBuffer
| HardwareBuffer (Usage usage, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
template<typename T>
T * | _getImpl ()
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required.
void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes.
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked.
virtual bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
virtual void | readData (size_t offset, size_t length, void *pDest)
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
void | unlock (void)
| Releases the lock on this buffer.
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

## Additional Inherited Members

Public Types inherited from Ogre::HardwareBuffer
enum | LockOptions : uint8 { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
typedef uint8 | Usage
enum | UsageEnum { HBU_STATIC = HBU_GPU_TO_CPU , HBU_DYNAMIC = HBU_CPU_ONLY , HBU_WRITE_ONLY = HBU_DETAIL_WRITE_ONLY , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = HBU_GPU_ONLY , HBU_DYNAMIC_WRITE_ONLY = HBU_CPU_TO_GPU , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = HBU_CPU_TO_GPU }
| Rather use HardwareBufferUsage. More...

## Detailed Description

Specialisation of HardwareBuffer for a vertex buffer.

## Constructor & Destructor Documentation

## HardwareVertexBuffer() [1/2]

Ogre::HardwareVertexBuffer::HardwareVertexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | size_t | vertexSize,
|  | size_t | numVertices,
|  | Usage | usage,
|  | bool | useShadowBuffer )

Should be called by HardwareBufferManager.

## HardwareVertexBuffer() [2/2]

Ogre::HardwareVertexBuffer::HardwareVertexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | size_t | vertexSize,
|  | size_t | numVertices,
|  | HardwareBuffer * | delegate )

References Ogre::HardwareBuffer::HardwareBuffer().

## ~HardwareVertexBuffer()

Ogre::HardwareVertexBuffer::~HardwareVertexBuffer | ( |  | ) |

## Member Function Documentation

## getManager()

HardwareBufferManagerBase * Ogre::HardwareVertexBuffer::getManager | ( |  | ) | const

inline

Return the manager of this buffer, if any.

## getVertexSize()

uint32 Ogre::HardwareVertexBuffer::getVertexSize | ( | void |  | ) | const

inline

Gets the size in bytes of a single vertex in this buffer.

## getNumVertices()

uint32 Ogre::HardwareVertexBuffer::getNumVertices | ( | void |  | ) | const

inline

Get the number of vertices in this buffer.

## isInstanceData()

bool Ogre::HardwareVertexBuffer::isInstanceData | ( |  | ) | const

inline

Get if this vertex buffer is an "instance data" buffer (per instance).

## setIsInstanceData()

void Ogre::HardwareVertexBuffer::setIsInstanceData | ( | const bool | val | ) |

Set if this vertex buffer is an "instance data" buffer (per instance).

## getInstanceDataStepRate()

uint32 Ogre::HardwareVertexBuffer::getInstanceDataStepRate | ( |  | ) | const

Get the number of instances to draw using the same per-instance data before advancing in the buffer by one element.

## setInstanceDataStepRate()

void Ogre::HardwareVertexBuffer::setInstanceDataStepRate | ( | const size_t | val | ) |

Set the number of instances to draw using the same per-instance data before advancing in the buffer by one element.

The documentation for this class was generated from the following file:

- OgreHardwareVertexBuffer.h